<?php
// SNE Ver1.28.3 ～ 1.29.05α用ログ読み込み
// ログからユニークな地震IDを取り出す
include_once("config.phps");

if(defined("__PAST_LOG") && file_exists(__PAST_LOG)){	// 過去ログ処理
	$line1 = file(__PAST_LOG);
}
if(defined("__SNE_LOG") && file_exists(__SNE_LOG)){		// 通常のログ処理
	$line2 = file(__SNE_LOG);
}
if(isset($line1)){
	$line = array_merge($line1,$line2);
} else {
	$line = $line2;
}
$j = 0;
if(count($line) > 0){
	$selected = -1;
	for($i=0;$i<count($line)-1;$i++){
		if(mb_ereg("地震情報",$line[$i])){
			$str_target = $line[$i];
			if(!mb_ereg("震央距離異常地震",$str_target)){
				if(mb_ereg("（震源の深さが150km以上）",$str_target)){
					$str_target = mb_ereg_replace("（震源の深さが150km以上）", ",",$str_target);
				}
				$item = mb_split(",",$str_target);
	
				$check = false;
				for($k=0;$k<count($item);$k++){
					$content = mb_split("=",$item[$k]);
					if($content[0] == "地震ID"){
						$num = strpos($content[1],"(");
						if($j == 0 || in_array(substr($content[1],0,$num),$eIdA) == false){
							$eIdA[$j] = substr($content[1],0,$num);
							if(@isset($eId) && $eIdA[$j] == $eId){
								$selected = $j;
							}
							$check = true;
							break;
						}
					}
				}

				if($check){
					for($k=1;$k<count($item);$k++){
						$content = mb_split("=",$item[$k]);
						switch($content[0]){
							case "地震発生時刻":
								$arrdate = split(" ",$content[1]);
								$date[$j] = str_replace("/","-",$arrdate[0]);
								$time[$j] = $arrdate[1];
								break;

							case "震源地緯度/経度":
								$epi[$j] = $content[1];
								break;

							case "マグニチュード":
								$t_mag = $content[1];
								if(strlen($t_mag . "") == 1) $t_mag .= ".0";
								$a_mag[$j] = $t_mag;
								break;

							case "震源の深さ":
								$depth[$j] = str_replace(".0","",$content[1]);
								break;

							case "観測地緯度/経度":
								$home[$j] = $content[1];
								break;

							case "震度":
								$t_level = round($content[1],1);
								if(strlen($t_level . "") == 1) $t_level .= ".0";
								$a_level[$j] = $t_level;
								break;
						}
					}
					$j++;
				}
			}
		}
	}

	$k = 1;
	for($i=0;$i<$j;$i++){
		if($i == 0){
			print("<optgroup label='$date[$i]'>\n");
		} else if($date[$i] != $date[$i-1]){
			print("</optgroup>\n<optgroup label='$date[$i]'>\n");
			$k = 1;
		}

		if($k == 7){
			$str = "class='br'";
			$k = 0;
		} else if($i == $j-1 || $i < $j-1 && $date[$i] != $date[$i+1]){
			$str = "class='br'";
		} else {
			$str = "";
		}

		if($i == $selected || ($selected == -1 && $i == $j-1)){
			print("<option $str value='$eIdA[$i],$epi[$i],$a_mag[$i],$depth[$i],$home[$i],$a_level[$i]' selected='selected'>" . sprintf("%08s",$time[$i]) . "</option>\n");
		} else {
			print("<option $str value='$eIdA[$i],$epi[$i],$a_mag[$i],$depth[$i],$home[$i],$a_level[$i]'>" . sprintf("%08s",$time[$i]) . "</option>\n");
		}
		$k++;

	}
	print("</optgroup>\n");
}
