<?php
set_time_limit(5);
include_once("nied_point.phps");
if($_GET['url'] != ""){
	$url = $_GET['url'];
} else {
	$time = (round(time() / 2) - 4) * 2;
	$url = "http://realtime-earthquake-monitor.appspot.com/jma_s/" . date("YmdHis",$time);
}
try{
	if(@file_get_contents($url)){
		$file = file_get_contents($url);
		if(@imagecreatefromstring($file)) {
			$img_src = imagecreatefromstring($file);
			$size = getimagesize($url);
			$type = $size["mime"];

			$points = 0;
			$max = 0;
			$names = "";
			$list_names = "";
			if($_COOKIE['level']){
				$report_level = $_COOKIE['level'];
			} else {
				$report_level = 1;
			}
			if($_COOKIE['b_level']){
				$listup_level = $_COOKIE['b_level'];
			} else {
				$listup_level = 3;
			}
			if($_COOKIE['nearest']){
				$nearest = $_COOKIE['nearest'];
			} else {
				$nearest = 1000;
			}

			if($_COOKIE['checkpoints']){
				$checkpoints = array();
				$checkpoints = split(",",$_COOKIE['checkpoints']);
				$max_green = 0;
				$min_blue = 255;
				$max_color = "#44fc34";
				$nearest_color = "#44fc34";
				$nearest_level = "0以下";
				$no_res_points = array();
			
				for($i=0;$i<count($checkpoints);$i++){
					$j = $checkpoints[$i];
					$rgb = imagecolorat($img_src, $nied_p[$j][2], $nied_p[$j][3]);
					$blue = $rgb & 0xFF;
		//			$green = ($rgb >> 8) & 0xFF;
					$red = ($rgb >> 16) & 0xFF;
					$level = 0;
					if($blue == 0){		// ほぼ震度2以上
						if($red > 150){
							$green = ($rgb >> 8) & 0xFF;
							if($green <= 36){
								$level = 2 + round((255 - $green) / 36, 1);
							} else {
								$level = 3 + round(((255 - $green) - 36) / (219 / 3), 1);
							}
						}
					} else if($blue <= 10){	// ほぼ震度1～2
						$level = 2 - round($blue / 10, 1);
					} else if($blue <= 52){	// ほぼ震度0～1
						$level = 1 - round(($blue - 10) / 42, 1);
					} else {
						$green = ($rgb >> 8) & 0xFF;
						if($red > 128){
							$no_res_points[] = $j;
						} else if($green > $max_green){
							$max_green = $green;
		//				} else if($blue < $min_blue){
		//					$min_blue = $blue;
							if($max == 0){
								$max_color = "#" . sprintf("%06s",dechex($rgb));
								$max_point = $j;
							}
						}
					}
					if($j == $nearest){
						if($level > 0){
							$nearest_level = sprintf("%0.1f",$level);
						}
						$nearest_color = "#" . sprintf("%06s",dechex($rgb));
					}
					if($level >= $report_level){
						$points++;
					}
					if($level > $listup_level){
						$list_names .= $nied_p[$j][0] . "(" . $nied_p[$j][1] . ")<br />";
					}
					if($level > $max){
						$max = $level;
						$max_color = "#" . sprintf("%06s",dechex($rgb));
						$max_point = $j;
						$names = $nied_p[$j][0] . "(" . $nied_p[$j][1] . ")";
					} else if($max > 0 && $level == $max){
						$names .= "<br />" . $nied_p[$j][0] . "(" . $nied_p[$j][1] . ")";
					}
				}
				if($max == 0){
					$max = "0以下";
				} else {
					$max = sprintf("%0.1f",$max);
				}
				print("<dt>確認日時</dt><dd>" . date("Y-m-d",$time) . " " . date("H:i:s",$time) . "</dd>\n");
				print("<dt>震度" . sprintf("%0.1f",$report_level) . "以上</dt><dd><span id='points_num'>" . $points . "</span> / " . (count($checkpoints) - count($no_res_points)). "(欠測:" . count($no_res_points) . ")</dd>\n");
				print("<dt>最大震度</dt><dd id='max'>" . $max . "<br /><span id='names'>" . $names . "</span><span id='color'>" . $max_color . "</span><span id='nearest_level'>" . $nearest_level . "</span><span id='nearest_color'>" . $nearest_color . "</span><span id='max_point' style='display:none'>" . $max_point . "</span></dd>\n");
				print("<dt style='display:none'>欠測点</dt><dd style='display:none' id='no_res_points'>" . join(",",$no_res_points) . "</dd>\n");
				if($list_names != ""){
					print("<dt style='display:none'>震度" . sprintf("%0.1f",$listup_level) . "以上</dt><dd style='display:none' id='listup'><span>震度" . sprintf("%0.1f",$listup_level) . "以上</span><br />" . $list_names . "</dd>\n");
				} else {
					print("<dt style='display:none'>震度" . sprintf("%0.1f",$listup_level) . "以上</dt><dd style='display:none' id='listup'></dd>\n");
				}
				$white = imagecolorclosest($img_src, 255, 255, 255);
				imagefilledrectangle($img_src, 150, 340, 351, 399, $white);
				imagecolortransparent($img_src, $white);
				ob_start();
				imagepng($img_src);
				$outputBuffer = ob_get_clean();
		
				$type_prefix = "data:" . $type . ";base64,";
			//	$base64file = base64_encode($file);
				$base64file = base64_encode($outputBuffer);
				$data_url = $type_prefix . $base64file;
				print("<dt style='display:none'>base64</dt><dd id='img_src' style='display:none'>" . $data_url . "</dd>");
			} else {
				print("<dt>Cookieエラー</dt><dd>ブラウザのcookieが無効になっています</dd>\n");
			}
			imagedestroy($img_src);
		} else {
			header('HTTP/1.0 400 Bad Request');
		}
	} else {
		print("<dt>強震モニタサーバーエラー</dt><dd>KiK-netの強震モニタサーバーが応答しません。</dd>\n");
	}
} catch (Exception $e) {

}
?>
